Option Explicit
Option Default None
Option AutoRun On
Const maxclocks = 19
Const OptionDisplayDate = 1
Const ana.x = MM.HRes/2
Const ana.y = MM.VRes/2 + 11
Const ana.r = MM.VRes/2 - 14
Const c.background = RGB(black)
Const c.title = RGB(232,0,232)
Const c.face = RGB(32,32,96)
Const c.bezel = RGB(white)
Const c.majormark = RGB(green)
Const c.minormark = RGB(green)
Const c.hourhand = RGB(yellow)
Const c.minutehand = RGB(cyan)
Const c.secondhand = RGB(red)
Const c.digital = RGB(cyan)
Const c.date = RGB(0,244,0)
Const c.caption = RGB(green)
Const c.button = RGB(cyan)
Const c.save = RGB(white)
Const c.delete = RGB(magenta)
Const c.entry = RGB(yellow)
Const c.special = RGB(red)
Const c.ghosttext = RGB(gray)
Dim Float ClockNbr = 0
Dim Integer TZ(maxclocks)
Dim Float ClockType(maxclocks) = (3,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
Dim String Title(maxclocks) Length 14 = ("UTC/GMT","PERTH (WST)","SYDNEY (EST)","NEW YORK","PARIS","#6","#7","#8","#9","#10","#11","#12","#13","#14","#15","#16","#17","#18","#19","#20")
Dim Float SM(maxclocks),SW(maxclocks),SD(maxclocks)
Dim Float EM(maxclocks),EW(maxclocks),ED(maxclocks)
Dim string arg$(20),OldTime$
Dim Float PrevClockType,TimeSource
Dim Integer i,PrevSec,NotSyncTime
Dim Integer key_coord(17,5)
Dim String key_caption(17)
Dim Integer x1(3),y1(3),x2(3),y2(3),x3(3),y3(3)
Dim Integer x1s0,x2s0,x3s0,y1s0,y2s0,y3s0,x1s1,x2s1,x3s1,y1s1,y2s1,y3s1
Dim Integer c(3) = (c.face,c.face,c.hourhand,c.minutehand)
Dim string baud(5) LENGTH 8 = ("","4800","9600","14400","19200","38400")
Dim Integer md(12) = (0,0,31,59,90,120,151,181,212,243,273,304,334)
Dim String mths(12) LENGTH 8 = ("Disabled","Jan","Feb","March","April","May","June","July","Aug","Sept","Oct","Nov","Dec")
Dim String days(6) LENGTH 10 = ("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")
Dim String abrevdays(6) LENGTH 8 = ("Sunday","Monday"," Tues "," Wedn ","Thurs","Friday"," Sat  ")
Dim String dstdow(3) LENGTH 8 = ("1st ","2nd ","3rd ","Last ")
Dim Integer UTC
Dim Integer tyear,tmth,tday,tdow,thour,tmin,tsec,tdst
CLS
'I2C Open 100,200,PU
I2C Write &H68,0,1,0
If MM.I2C <> 0 Then I2C Write &H51,0,1,2
If MM.I2C = 0 Then
TimeSource = 1
RTC GetTime
If Date$ = "01-01-2000" Then
MessageBox "RTC has invalid","date and time"
RTC SetTime 16,1,1,0,0,0
Time$ = "00:00:00" : Date$ = "01/01/16"
EndIf
SetTick 600000,RtcSetTime
Else
CLS
Text MM.HRes/2,MM.VRes/2 - 20,"RTC not found",CM,1,2,RGB(white)
Text MM.HRes/2,MM.VRes/2 + 20,"Checking for GPS",CM,1,2,RGB(white)
For i = 1 To 5
WatchDog 4000
Open "COM1:" + baud(i) As #1
Pause 1000
If Instr(Input$(255,#1),"$GP") > 0 Then TimeSource = 2 : GoTo ExitGPS
Close #1
WatchDog 4000
Open "COM1:" + baud(i) + ",INV" As #1
Pause 1000
If Instr(Input$(255,#1),"$GP") > 0 Then TimeSource = 2 : GoTo ExitGPS
Close #1
Next i
CLS
WatchDog 20000
MessageBox "No RTC or GPS","Time is not set"
TimeSource = 0
Time$ = "00:00:00" : Date$ = "01/01/16"
EndIf
ExitGPS:
If TimeSource = 2 Then
Do
WatchDog 4000
GetRMCRecord
If arg$(2) = "V" Then
CLS
Text MM.HRes/2,MM.VRes/2 - 20,"Searching For",CM,1,2,RGB(white)
Text MM.HRes/2,MM.VRes/2 + 20,"Satellites",CM,1,2,RGB(white)
Continue Do
EndIf
Loop While arg$(2) = "V"
EndIf
UTC = GetSec(Val(Right$(Date$,2)),Val(Mid$(Date$,4,2)),Val(Left$(Date$,2)),Val(Left$(Time$,2)),Val(Mid$(Time$,4,2)),Val(Right$(Time$,2)))
GetLocalTime
TZ(1) = 28800 : TZ(2) = 36000 : TZ(3) = -18000 : TZ(4) = 3600
SM(2) = 10 : EM(2) = 4
SM(3) = 3 : SW(3) = 1 : EM(3) = 11
SM(4) = 3 : SW(4) = 3 : EM(4) = 10 : EW(4) = 3
VAR Restore
InitClock
Do
WatchDog 5000
If TimeSource < 2 Then
Do While OldTime$ = Time$ And Touch(x) = -1 : Loop
OldTime$ = Time$
Else
arg$(0) = ""
GetRMCRecord
If arg$(2) = "A" Then
NotSyncTime = UTC
Else
If UTC - NotSyncTime > 24 * 3600 Then CPU Reset
EndIf
EndIf
Select Case Touch(X)
Case 0 To 120
Do : Loop Until Touch(X) = -1
Do
ClockNbr = ClockNbr - 1
If ClockNbr < 0 Then ClockNbr = maxclocks
Loop While ClockType(ClockNbr) = 0
VAR Save ClockNbr
InitClock
Case 121 To 219
Do : Loop Until Touch(X) = -1
ConfigureMenu
PrevClockType = 0
InitClock
Case 220 To 340
Do : Loop Until Touch(X) = -1
Do
ClockNbr = (ClockNbr + 1) Mod (maxclocks + 1)
Loop While ClockType(ClockNbr) = 0
VAR Save ClockNbr
InitClock
Case Else
UTC = GetSec(Val(Right$(Date$,2)),Val(Mid$(Date$,4,2)),Val(Left$(Date$,2)),Val(Left$(Time$,2)),Val(Mid$(Time$,4,2)),Val(Right$(Time$,2)))
GetLocalTime
If ClockType(ClockNbr) = 1 Then
UpdateAnalog tsec,tmin,thour
Else
If ClockType(ClockNbr) = 2 And tmin = 0 And tsec = 0 And (thour = 1 Or thour =10 Or thour = 13 Or thour = 22) Then PrevClockType = 0 : InitClock
UpdateDigital tsec,tmin,thour
EndIf
End Select
Loop
Sub GetGPSRecord
Local integer i
Local string x$
Do
Do While Input$(1,#1) <> "$"
If Touch(x) <> -1 Then Exit Sub
Loop
For i = 0 To 20
arg$(i) = ""
Do
If Touch(x) <> -1 Then Exit Sub
x$ = Input$(1,#1)
If x$ = "," Then Exit
If x$ = "*" Then Exit Sub
arg$(i) = arg$(i) + x$
Loop
Next i
Loop
End Sub
Sub GetRMCRecord
Do
If Touch(x) <> -1 Then Exit Sub
GetGPSRecord
Loop Until arg$(0) = "GPRMC"
If Val(Right$(arg$(9),2)) >= 16 Then
Date$ = Left$(arg$(9),2) + "/" + Mid$(arg$(9),3,2) + "/" + Right$(arg$(9),2)
Time$ = Left$(arg$(1),2) + ":" + Mid$(arg$(1),3,2) + ":" + Mid$(arg$(1),5,2)
Else
arg$(2) = "V"
EndIf
End Sub
Sub InitClock
Local Float i,y,xx,yy,r1,r2,tim
GetLocalTime
If ClockType(ClockNbr) = 1 Then
If PrevClockType = 1 Then
Text MM.HRes/2,-3,"      " + Title(ClockNbr) + "      ",CT,1,2,c.title,c.background
Circle ana.x,ana.y,ana.r - 21,0,1,0,c.face
Else
CLS c.background
Text MM.HRes/2,-3,"      " + Title(ClockNbr) + "      ",CT,1,2,c.title,c.background
Circle ana.x,ana.y,ana.r,5,1,c.bezel,c.face
For i = 0 To 59
If i Mod 15 = 0 Then
For y = -2 To +2
tim = (i + y/10) : xx = Cos(Rad(tim * 6)) : yy = Sin(Rad(tim * 6))
r1 = ana.r - 20 : r2 = ana.r - 5
Line ana.x + xx*r1,ana.y - yy*r1,ana.x + xx*r2,ana.y - yy*r2,1,c.majormark
Next y
ElseIf i Mod 5 = 0 Then
For y = -2 To +2
tim = (i + y/10) : xx = Cos(Rad(tim * 6)) : yy = Sin(Rad(tim * 6))
r1 = ana.r - 15 : r2 = ana.r - 5
Line ana.x + xx*r1,ana.y - yy*r1,ana.x + xx*r2,ana.y - yy*r2,1,c.majormark
Next y
Else
tim = i : xx = Cos(Rad(tim * 6)) : yy = Sin(Rad(tim * 6))
r1 = ana.r - 10 : r2 = ana.r - 5
Line ana.x + xx*r1,ana.y - yy*r1,ana.x + xx*r2,ana.y - yy*r2,1,c.majormark
EndIf
Next i
EndIf
UpdateAnalog -1,tmin,thour
UpdateAnalog -1,tmin,thour
Else
CLS c.background
Text MM.HRes/2,5,"      " + Title(ClockNbr) + "      ",CT,2,1,c.title,c.background
UpdateDigital -1,tmin,thour
EndIf
PrevClockType = ClockType(ClockNbr)
End Sub
Sub UpdateDigital s As Float,m As Float,h As Float
Local Float sec = s,min = m,hr = h,offset
Local String st
If ClockType(ClockNbr) = 2 Then
If Not ((hr >= 10 And hr < 13) Or hr >= 22 Or hr = 0) Then offset = -20
If sec <= 0 Then
If hr < 12 Then st = "AM" Else st = "PM"
Text MM.HRes + 3 + offset,54,st,RT,2,1,c.digital
If hr > 12 Then hr = hr - 12
If hr = 0 Then hr = 12
EndIf
Else
offset = 6
EndIf
If sec <= 0 Then
If ClockType(ClockNbr) = 2 Then
Text -8 + offset,50,Str$(hr,2),,3,1,c.digital
Else
Text -8 + offset,50,Str$(hr,2,0,"0"),,3,1,c.digital
EndIf
Text 141 + offset,50,Str$(min,2,0,"0"),,3,1,c.digital
Circle 130 + offset,80,6,0,1,0,c.digital
Circle 130 + offset,122,6,0,1,0,c.digital
If OptionDisplayDate Then
Text MM.HRes/2,MM.VRes - 40,"   " + days(tdow) + "   ",CB,2,1,c.date
Text MM.HRes/2,MM.VRes - 5,"   " + Str$(tday) + " " + mths(tmth) + " " + Str$(tyear + 2000) + "   ",CB,2,1,c.date
EndIf
EndIf
If ClockType(ClockNbr) = 3 Then offset = 3
If sec >= 0 Then Text MM.HRes + 2 + offset,152,Str$(sec,2,0,"0"),RB,2,1,c.digital
End Sub
Sub UpdateAnalog s As Float,m As Float,h As Float
Local Float minutes = m - 15,hour = (h - 3) + m/60,sec = s - 15
If hour >= 12 Then hour = hour - 12
Line ana.x,ana.y,GetX(PrevSec,ana.r - 21),GetY(PrevSec,ana.r - 21),1,c.face
PrevSec = sec
If s > 0 Then
Circle ana.x,ana.y,ana.r * 0.075,1,1,c.hourhand,c.hourhand
If x1(0) <> 0 Then
x1s0=x1(0):x2s0=x2(0):x3s0=x3(0):y1s0=y1(0):y2s0=y2(0):y3s0=y3(0)
x1(0)=0:x2(0)=0:x3(0)=0:y1(0)=0:y2(0)=0:y3(0)=0
x1s1=x1(1):x2s1=x2(1):x3s1=x3(1):y1s1=y1(1):y2s1=y2(1):y3s1=y3(1)
x1(1)=0:x2(1)=0:x3(1)=0:y1(1)=0:y2(1)=0:y3(1)=0
Triangle x1(),y1(),x2(),y2(),x3(),y3(),c(),c()
x1(0)=x1s0:x2(0)=x2s0:x3(0)=x2s0:y1(0)=y1s0:y2(0)=y2s0:y3(0)=y3s0
x1(1)=x1s1:x2(1)=x2s1:x3(1)=x2s1:y1(1)=y1s1:y2(1)=y2s1:y3(1)=y3s1
EndIf
Else
x1(0) = x1(2) : x1(1) = x1(3) : y1(0) = y1(2) : y1(1) = y1(3)
x2(0) = x2(2) : x2(1) = x2(3) : y2(0) = y2(2) : y2(1) = y2(3)
x3(0) = x3(2) : x3(1) = x3(3) : y3(0) = y3(2) : y3(1) = y3(3)
x1(2) = GetX((hour * 5) - 15,ana.r * 0.075)
y1(2) = GetY((hour * 5) - 15,ana.r * 0.075)
x2(2) = GetX((hour * 5) + 15,ana.r * 0.075)
y2(2) = GetY((hour * 5) + 15,ana.r * 0.075)
x3(2) = GetX(hour * 5,ana.r * 0.55)
y3(2) = GetY(hour * 5,ana.r * 0.55)
x1(3) = GetX(minutes - 15,ana.r * 0.05)
y1(3) = GetY(minutes - 15,ana.r * 0.05)
x2(3) = GetX(minutes + 15,ana.r * 0.05)
y2(3) = GetY(minutes + 15,ana.r * 0.05)
x3(3) = GetX(minutes,ana.r - 21)
y3(3) = GetY(minutes,ana.r - 21)
Circle ana.x,ana.y,ana.r * 0.075,1,1,c.hourhand,c.hourhand
If x1(0) <> 0 Then Triangle x1(),y1(),x2(),y2(),x3(),y3(),c(),c()
If OptionDisplayDate Then
Text 47,MM.VRes,abrevdays(tdow),CB,1,2,c.date
Text MM.HRes + 1,MM.VRes,Str$(tday,2) + " " + Left$(mths(tmth),3),RB,1,2,c.date
EndIf
EndIf
If s >= 0 Then Line ana.x,ana.y,GetX(sec,ana.r - 21),GetY(sec,ana.r - 21),1,c.secondhand
Circle ana.x,ana.y,ana.r * 0.05,1,1,c.minutehand,c.minutehand
End Sub
Function GetX(tim As Float,r As Float) As Integer
Local Float t = tim
If t > 359 Then t = t - 360
If t < 0 Then t = t + 360
GetX = ana.x + Cos(Rad(t * 6)) * r
End Function
Function GetY(tim As Float,r As Float) As Integer
Local Float t = tim
If t > 359 Then t = t - 360
If t < 0 Then t = t + 360
GetY = ana.y + Sin(Rad(t * 6)) * r
End Function
Sub ConfigureMenu
  Local Float i, j, btn
  Local String modes(3) LENGTH 16 = ("Hidden     ", "Analogue   ", "Digital 12h", "Digital 24h")
  redisplay:
  WatchDog 1200000
  CLS
  Font 1, 2
  Text MM.HRes/2, 0, Title(ClockNbr), CT, 2, 1, c.title, c.background
  Text 5, 40, modes(ClockType(ClockNbr)), , , , c.caption
  DrawButton 0, 0, MM.HRes - 120, 38, 120, 30, c.button, "CHANGE"
  DrawButton 1, 0, 30, 85, 260, 30, c.button, "CONFIGURE CLOCK"
  If TimeSource < 2 Then
    DrawButton 2, 0, 10, 140, 140, 30, c.button, "SET DATE"
    DrawButton 3, 0, MM.HRes - 150, 140, 140, 30, c.button, "SET TIME"
    Text MM.HRes/2, 172, "Setting date and time will also adjust",C ,1 ,1 , c.entry
    Text MM.HRes/2, 185, "all other clocks based on their timezone",C ,1 ,1 , c.entry
  Else
    Text MM.HRes/2, 130, "GPS Time", C, 1, 2, c.entry
    If UTC - NotSyncTime = 0 Then
      Text MM.HRes/2, 158, "Synchronised", C, 1, 2, c.entry
    Else
      Text 0, 158, "No sync for " + Str$((UTC - NotSyncTime + 36)/3600, 1, 2) + " hrs", , 1, 2, c.entry
    EndIf
  EndIf
  DrawButton 4, 0, 0, 211, 90, 30, c.special, "PREV"
  DrawButton 5, 0, 110, 211, 100, 30, c.save, "EXIT"
  DrawButton 6, 0, MM.HRes-90, 211, 90, 30, c.special, "NEXT"
  Do
    btn = CheckButtonPress(0, 6)
    If btn >= 0 Then
      Timer = 0
      Pause 200
      If btn = 3 Then
        Do While TimeSource = 1 And Touch(x) <> -1 And Timer < 3000 : Loop
        If Timer >= 3000 Then
          TrimAging
          GoTo redisplay
        EndIf
      EndIf
      CheckButtonRelease btn
    EndIf
    Select Case btn
      Case 0
        ClockType(ClockNbr) = (ClockType(ClockNbr) + 1) Mod 4
        Text 5, 40, modes(ClockType(ClockNbr)), , , , c.caption
      Case 1
        ConfigureClock
        GoTo redisplay
      Case 2
        GetDateTime 1
        GoTo redisplay
      Case 3
        GetDateTime 0
        GoTo redisplay
      Case 4
        ClockNbr = ClockNbr - 1
        If ClockNbr < 0 Then ClockNbr = maxclocks
        Text MM.HRes/2, 0, "     " + Title(ClockNbr) + "     ", CT, 2, 1, c.title, c.background
        Text 5, 40, modes(ClockType(ClockNbr)), , , , c.caption
      Case 5
        j = 0
        For i = 0 To maxclocks : j = j + ClockType(i) : Next i
        If j = 0 Then ClockType(0) = 1
        Do While ClockType(ClockNbr) = 0
          ClockNbr = (ClockNbr + 1) Mod (maxclocks + 1)
        Loop
        VAR Save ClockNbr, ClockType()
        Exit Do
      Case 6
        ClockNbr = (ClockNbr + 1) Mod (maxclocks + 1)
        Text MM.HRes/2, 0, "     " + Title(ClockNbr) + "     ", CT, 2, 1, c.title, c.background
        Text 5, 40, modes(ClockType(ClockNbr)), , , , c.caption
    End Select
  Loop
End Sub

Sub ConfigureClock
Local String StartDst,EndDst
Local Integer btn
restartmenu:
StartDst = dstdow(SW(ClockNbr)) + Left$(days(SD(ClockNbr)),3) + " in " + Left$(mths(SM(ClockNbr)),3)
EndDst = dstdow(EW(ClockNbr)) + Left$(days(ED(ClockNbr)),3) + " in " + Left$(mths(EM(ClockNbr)),3)
If SM(ClockNbr) = 0 Then StartDst = "Disabled"
If EM(ClockNbr) = 0 Then EndDST = "Disabled"
CLS
Font 1,2
Text 0,0,"Title:",,,,c.caption
Text 0,26,Title(ClockNbr),,,,c.entry
DrawButton 0,0,MM.HRes - 75,8,75,30,c.button,"SET"
Text 0,60,"TimeZone:",,,,c.caption
Text 152,60,Str$(TZ(ClockNbr)/3600,-1,1),,,,c.entry
DrawButton 1,0,MM.HRes - 75,58,35,30,c.button,"-"
DrawButton 2,0,MM.HRes - 35,58,35,30,c.button,"+"
Text 0,94,"DST Start:",,,,c.caption
Text 0,118,StartDst,,,,c.entry
DrawButton 3,0,MM.HRes - 75,116,75,30,c.button,"SET"
Text 0,152,"DST End:",,,,c.caption
Text 0,176,EndDst,,,,c.entry
DrawButton 4,0,MM.HRes - 75,172,75,30,c.button,"SET"
DrawButton 5,0,100,MM.VRes - 30,120,30,c.save,"SAVE"
Do
btn = CheckButtonPress(0,6)
Select Case btn
Case 0
Pause 200
CheckButtonRelease btn
GetString Title(ClockNbr)
GoTo restartmenu
Case 1
TZ(ClockNbr) = TZ(ClockNbr) - (3600/2)
If TZ(ClockNbr) < (-12 * 3600) Then TZ(ClockNbr) = (-12 * 3600)
Text 152,60,Left$(Str$(TZ(ClockNbr)/3600,-1,1),5),,,,c.entry
Pause 200
CheckButtonRelease btn
Case 2
TZ(ClockNbr) = TZ(ClockNbr) + (3600/2)
If TZ(ClockNbr) > (12 * 3600) Then TZ(ClockNbr) = (12*3600)
Text 152,60,Left$(Str$(TZ(ClockNbr)/3600,-1,1),5),,,,c.entry
Pause 200
CheckButtonRelease btn
Case 3
Pause 200
CheckButtonRelease btn
GetDSTSettings 1
GoTo restartmenu
Case 4
Pause 200
CheckButtonRelease btn
GetDSTSettings 0
GoTo restartmenu
Case 5
VAR Save TZ(),Title()
Exit
End Select
Loop
End Sub
Sub GetDSTSettings st As Float
Local Integer btn
Local Float m,w,d
CLS
Font 1,2
If st Then
Text MM.HRes/2,0,"DST Start",C,,,RGB(brown)
m = SM(ClockNbr) : w = SW(ClockNbr) : d = SD(ClockNbr)
Else
Text MM.HRes/2,0,"DST End",C,,,RGB(brown)
m = EM(ClockNbr) : w = EW(ClockNbr) : d = ED(ClockNbr)
EndIf
Text 0,32,"Month:",,,,c.caption
Text 20,58,mths(m),,,,c.entry
DrawButton 0,0,MM.HRes - 105,56,50,30,c.button,"-"
DrawButton 1,0,MM.HRes - 50,56,50,30,c.button,"+"
Text 0,90,"Day:",,,,c.caption
Text 20,116,days(d),,,,c.entry
DrawButton 2,0,MM.HRes - 105,114,50,30,c.button,"-"
DrawButton 3,0,MM.HRes - 50,114,50,30,c.button,"+"
Text 0,148,"Week:",,,,c.caption
Text 20,174,dstdow(w),,,,c.entry
DrawButton 4,0,MM.HRes - 105,172,50,30,c.button,"-"
DrawButton 5,0,MM.HRes - 50,172,50,30,c.button,"+"
DrawButton 6,0,100,MM.VRes - 30,120,30,c.save,"SAVE"
Do
btn = CheckButtonPress(0,6)
Select Case btn
Case 0
m = m - 1
If m < 0 Then m = 12
Text 20,58,Left$(mths(m) + "      ",8),,,,c.entry
Case 1
m = m + 1
If m > 12 Then m = 0
Text 20,58,Left$(mths(m) + "      ",8),,,,c.entry
Case 2
d = d - 1
If d < 0 Then d = 6
Text 20,116,days(d) + "   ",,,,c.entry
Case 3
d = d + 1
If d > 6 Then d = 0
Text 20,116,days(d) + "   ",,,,c.entry
Case 4
w = w - 1
If w < 0 Then w = 3
Text 20,174,dstdow(w),,,,c.entry
Case 5
w = w + 1
If w > 3 Then w = 0
Text 20,174,dstdow(w),,,,c.entry
Case 6
If st Then
SM(ClockNbr) = m : SW(ClockNbr) = w : SD(ClockNbr) = d
VAR Save SM(),SW(),SD()
Else
EM(ClockNbr) = m : EW(ClockNbr) = w : ED(ClockNbr) = d
VAR Save EM(),EW(),ED()
EndIf
Exit
End Select
If btn >= 0 Then Pause 200 : CheckButtonRelease btn
Loop
End Sub
Sub GetDateTime dt As Integer
Local Integer digit,i,b,d,m,y
Local String SCap(9) LENGTH 8 = ("7","8","9","4","5","6","1","2","3","0")
Local String str,strold
Const bh = MM.VRes\5,bw = MM.HRes\5
If dt Then strold = "dd/mm/yy" Else strold = "hh:mm:ss"
str = strold
digit = 1
Font 1,2
CLS
For i = 0 To 8
DrawButton i,0,bw + bw * (i Mod 3) + 2,bh + bh * (i \ 3) + 2,bw - 4,bh - 4,c.button,SCap(i)
Next i
DrawButton 9,0,bw*2 + 2,bh*4 + 2,bw - 4,bh - 4,c.button,"0"
DrawButton 10,0,0,bh*4 + 2,bw * 2 - 4,bh - 4,c.delete,"DELETE"
DrawButton 11,0,bw*3 + 2,bh*4 + 2,bw * 2 - 4,bh - 4,c.save,"SAVE"
DisplayDateTimeStr str
Do
If Timer > 700 Then Line 40 + digit * 24,43,64 + digit * 24,43,2,c.entry : Timer = 0
b = CheckButtonPress(0,11)
If Timer > 500 Or b > 0 Then Line 40 + digit * 24,43,64 + digit * 24,43,2,0
Select Case b
Case 0 To 9
If digit < 9 Then
str = Mid$(str,1,digit-1) + SCap(b) + Mid$(str,digit+1,9)
digit = digit + 1
If digit = 3 Or digit = 6 Then digit = digit + 1
DisplayDateTimeStr str
EndIf
Pause 150
CheckButtonRelease b
Case 10
If digit > 1 Then
digit = digit - 1
If digit = 3 Or digit = 6 Then digit = digit - 1
str = Mid$(str,1,digit-1) + Mid$(strold,digit)
DisplayDateTimeStr str
EndIf
Pause 150
CheckButtonRelease b
Case 11
Pause 150
CheckButtonRelease b
d = Val(Left$(str,2))
m = Val(Mid$(str,4,2))
y = Val(Right$(str,2))
If dt Then
If y < 16 Or m < 1 Or m > 12 Or d < 1 Or d > 31 Then
MessageBox "Invalid","Date"
Else
GetLocalTime
UTC = GetSec(y,m,d,thour,tmin,tsec) - TZ(ClockNbr) - tdst
GetLocalTime
UTC = GetSec(y,m,d,thour,tmin,tsec) - TZ(ClockNbr) - tdst
EndIf
Else
If Mid$(str,5,1) = "m" Or y > 59 Or m > 59 Or d > 23 Then
MessageBox "Invalid","Time"
Else
GetLocalTime
UTC = GetSec(tyear,tmth,tday,d,m,y) - TZ(ClockNbr) - tdst
GetLocalTime
UTC = GetSec(tyear,tmth,tday,d,m,y) - TZ(ClockNbr) - tdst
EndIf
EndIf
If TimeSource = 1 Then
RTC SetTime GetYear(UTC),GetMonth(UTC),GetDay(UTC),(UTC \ 3600) Mod 24,(UTC \ 60) Mod 60,UTC Mod 60
EndIf
Date$ = Str$(GetDay(UTC)) + "/" + Str$(GetMonth(UTC)) + "/" + Str$(GetYear(UTC))
Time$ = Str$((UTC \ 3600) Mod 24) + ":" + Str$((UTC \ 60) Mod 60) + ":" + Str$(UTC Mod 60)
Exit
End Select
EndIf
Loop
End Sub
Sub DisplayDateTimeStr s As String
Local Float i
For i = 1 To 8
If i = 3 Or i = 6 Then
Text 40 + 24 * i,10,Mid$(s,i,1),,2,1,RGB(white),0
ElseIf Mid$(s,i,1) > "9" Then
Text 40 + 24 * i,10,Mid$(s,i,1),,2,1,c.ghosttext,0
Else
Text 40 + 24 * i,10,Mid$(s,i,1),,2,1,c.entry,0
EndIf
Next i
End Sub
Sub GetString str As String
Local Integer i,b,y,xt,yt,SIndex
Local String strOriginal = str
Local String SCap(47) LENGTH 4 = ("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","1","2","3","4","5","6","7","8","9","0",",",".","?","-",":",";","(",")","@","#","$","&")
Const bh = MM.VRes\5,bw = MM.HRes\6
CLS
SIndex = 0
Text 0,10,str,,2,1,c.entry,0
y = (MM.VRes / 5) * 4 + 5
DrawButton 0,0,0,y,64,36,c.delete,"DEL"
DrawButton 1,0,80,y,96,36,c.button,"SPACE"
DrawButton 2,0,MM.HRes - 113,y,112,36,c.save,"SAVE"
For i = 0 To 11
DrawButton i + 3,0,bw + bw * (i Mod 4) + 2,bh + bh * (i \ 4) + 2,bw - 4,bh - 4,c.button,SCap(i)
Next i
DrawRArrow bw,bh
DrawLArrow bw,bh
Do
If Timer > 700 Then Text 0,10,str + "_",,2,1,c.entry,0 : Timer = 0
If Timer > 500 Then Text 0,10,str + " ",,2,1,c.entry,0
If Touch(x) <> -1 Then
xt = Touch(x)
yt = Touch(y)
If xt > bw * 5 + 10 And yt > (bh/2) * 3 And yt < (bh/2) * 7 And SIndex < 32 Then
DrawRArrowFilled bw,bh
SIndex = SIndex + 12
For i = 0 To 11
DrawButton i + 3,0,bw + bw * (i Mod 4) + 2,bh + bh * (i \ 4) + 2,bw - 4,bh - 4,c.button,SCap(i + SIndex)
Next i
Do While Touch(x) <> -1 : Loop
DrawRArrow bw,bh
Continue do
EndIf
If xt < bw And yt > (bh/2) * 3 And yt < (bh/2) * 7 And SIndex > 0 Then
DrawLArrowFilled bw,bh
SIndex = SIndex - 12
For i = 0 To 11
DrawButton i + 3,0,bw + bw * (i Mod 4) + 2,bh + bh * (i \ 4) + 2,bw - 4,bh - 4,c.button,SCap(i + SIndex)
Next i
Do While Touch(x) <> -1 : Loop
DrawLArrow bw,bh
Continue do
EndIf
b = CheckButtonPress(0,14)
Select Case b
Case 0
If Len(str) > 0 Then
str = Mid$(str,1,Len(str) - 1)
Text 0,10,str + "  ",,2,1,c.entry,0
EndIf
CheckButtonRelease 0
Case 1
If Len(str) < 12 Then
str = str + " "
Text 0,10,str,,2,1,c.entry,0
EndIf
CheckButtonRelease 1
Case 2
CheckButtonRelease 2
If str = "" Then str = strOriginal
Exit
Case 3 To 14
If Len(str) < 12 Then
str = str + SCap(SIndex + b - 3)
Text 0,10,str,,2,1,c.entry,0
EndIf
CheckButtonRelease b
End Select
EndIf
Loop
End Sub
Sub DrawRArrow bw As Integer,bh As Integer
Box bw * 5 + 10,(bh/2) * 3,bw,bh * 2,1,0,0
Line bw * 5 + 10,(bh/2) * 3,MM.HRes - 1,(bh/2) * 5,1,c.special
Line bw * 5 + 10,(bh/2) * 3,bw * 5 + 10,(bh/2) * 7,1,c.special
Line bw * 5 + 10,(bh/2) * 7,MM.HRes - 1,(bh/2) * 5,1,c.special
End Sub
Sub DrawLArrow bw As Integer,bh As Integer
Box 0,(bh/2) * 3,bw,bh * 2,1,0,0
Line bw - 10,(bh/2) * 3,0,(bh/2) * 5,1,c.special
Line bw - 10,(bh/2) * 3,bw - 10,(bh/2) * 7,1,c.special
Line bw - 10,(bh/2) * 7,0,(bh/2) * 5,1,c.special
End Sub
Sub DrawRArrowFilled bw As Integer,bh As Integer
Local Integer x,y
For x = bw * 5 + 10 To MM.HRes - 1
y = bh * ((x - (bw * 5 + 10)) / ((MM.HRes - 1) - (bw * 5 + 10)))
Line x,(bh/2) * 3 + y,x,(bh/2) * 7 - y,1,c.special
Next x
End Sub
Sub DrawLArrowFilled bw As Integer,bh As Integer
Local Integer x,y
For x = 0 To bw - 10
y = bh * (x / (bw - 10))
Line x,bh/2 * 5 - y,x,bh/2 * 5 + y,1,c.special
Next x
End Sub
Sub TrimAging
Local Integer r ,b
Local Float n
CLS
Font 2,1
Text MM.HRes/2,10,"DS3231",CT,2 ,1,c.caption
Text MM.HRes/2,45,"Aging Offset",CT,2,1,c.caption
RTC GetReg &H10,r
If MM.I2C > 0 Then
MessageBox "Error reading","from RTC"
Exit Sub
EndIf
If r > 127 Then
n = r - 256
Else
n = r
EndIf
Text 50,100,Str$(n,4,0,"0"),,2,1,c.entry
If n >= 0 Then Text 50,100,"+",,2,1,c.entry
DrawButton 0,0,200,95,50,42,c.button,"-"
DrawButton 1,0,260,95,50,42,c.button,"+"
Text MM.HRes/2,142,"Positive values will slow the clock,",CT,1,1,c.entry
Text MM.HRes/2,157,"negative values will speed it up",CT,1,1,c.entry
DrawButton 2,0,0,MM.VRes - 50,150,50,c.special,"CANCEL"
DrawButton 3,0,MM.HRes - 150,MM.VRes - 50,150,50,c.save,"SAVE"
Do While Touch(x) <> -1 : Loop
Do
b = CheckButtonPress(0,14)
Select Case b
Case 0
n = n - 1
If n < -127 Then n = -127
Text 50,100,Str$(n,4,0,"0"),,2,1,c.entry
If n >= 0 Then Text 50,100,"+",,2,1,c.entry
CheckButtonRelease 0
Case 1
n = n + 1
If n > 127 Then n = 127
Text 50,100,Str$(n,4,0,"0"),,2,1,c.entry
If n >= 0 Then Text 50,100,"+",,2,1,c.entry
CheckButtonRelease 1
Case 2
Exit
Case 3
r = n And &B11111111
RTC SetReg &H10,r
If MM.I2C > 0 Then
MessageBox "Error writing","to RTC"
EndIf
Exit
End Select
Loop
End Sub
Sub GetLocalTime
Local Integer t,ty,dststart,dstend
tdst = 0
t = UTC + TZ(ClockNbr)
If SM(ClockNbr) <> 0 And EM(ClockNbr) <> 0 Then
ty = GetYear(t)
dststart = GetDST(ty,Cint(SM(ClockNbr)),Cint(SW(ClockNbr)),Cint(SD(ClockNbr)))
dstend = GetDST(ty,Cint(EM(ClockNbr)),Cint(EW(ClockNbr)),Cint(ED(ClockNbr)))
If dststart > dstend Then
If t < dstend Then
dststart = GetDST(ty - 1,Cint(SM(ClockNbr)),Cint(SW(ClockNbr)),Cint(SD(ClockNbr)))
Else
dstend = GetDST(ty + 1,Cint(EM(ClockNbr)),Cint(EW(ClockNbr)),Cint(ED(ClockNbr)))
EndIf
EndIf
If t >= dststart And t < dstend Then tdst = 3600
t = t + tdst
EndIf
tsec = t Mod 60
tmin = (t \ 60) Mod 60
thour = (t \ 3600) Mod 24
tyear = GetYear(t)
tmth = GetMonth(t)
tday = GetDay(t)
tdow = GetDOW(t)
End Sub
Function GetSec(yr As Integer,mth As Integer,day As Integer,hr As Integer,min As Integer,sec As Integer) As Integer
GetSec = (yr - 14) * (365 * 24 * 60)
GetSec = GetSec + ((yr - 13) \ 4) * (24 * 60)
GetSec = GetSec + (md(mth) * (24 * 60))
GetSec = GetSec + ((day - 1) * (24 * 60))
GetSec = GetSec + (hr * 60)
GetSec = ((GetSec + min) * 60) + sec
If (yr - 16) Mod 4 = 0 And mth > 2 Then GetSec = GetSec + (24 * 3600)
End Function
Function GetYear(seconds As Integer) As Float
Local Float yr
For yr = 14 To 99
If seconds < GetSec(Cint(yr + 1),1,1,0,0,0) Then Exit For
Next yr
GetYear = yr
End Function
Function GetMonth(seconds As Integer) As Float
Local Float mth
For mth = 1 To 12
If seconds < GetSec(tyear,Cint(mth),1,0,0,0) Then Exit For
Next mth
GetMonth = mth - 1
End Function
Function GetDay(seconds As Integer) As Float
GetDay = ((seconds - GetSec(tyear,tmth,1,0,0)) \ (24 * 3600)) + 1
End Function
Function GetDOW(seconds As Integer) As Float
GetDOW = ((seconds \ (24 * 3600)) + 3) Mod 7
End Function
Function GetDST(yr As Integer,mth As Integer,wk As Integer,dy As Integer) As Integer
Local Integer d,m,hr = 2,ty = yr,tm = mth
If TZ(ClockNbr) = 0 Then hr = 1
m = GetSec(yr,mth,1,hr,0,0)
d = GetDOW(m)
m = m + (((dy - d + 7) Mod 7) * 24 * 3600)
GetDST = m + (wk * 7 * 24 * 3600)
If wk = 3 Then
tm = tm + 1
If tm > 12 Then tm = 1 : ty = ty + 1
If GetDST + (7 * 24 * 3600) < GetSec(ty,tm,1,0,0,0) Then GetDST = GetDST + (7 * 24 * 3600)
EndIf
End Function
Sub RtcSetTime
RTC GetTime
End Sub
Sub DrawButton n As Integer,mode As Integer,x As Integer,y As Integer,w As Integer,h As Integer,c As Integer,s As String
Local Integer bc,fc
If mode = 0 Then
key_coord(n,0) = x : key_coord(n,1) = y : key_coord(n,2) = w : key_coord(n,3) = h
key_coord(n,4) = c : key_caption(n) = s
EndIf
If mode > 1 Then
bc = key_coord(n,4) : fc = 0
Else
bc = 0 : fc = key_coord(n,4)
EndIf
RBox key_coord(n,0),key_coord(n,1),key_coord(n,2),key_coord(n,3),,key_coord(n,4),bc)
Text key_coord(n,0) + key_coord(n,2)/2,key_coord(n,1) + key_coord(n,3)/2,key_caption(n),CM,,,fc,bc
End Sub
Function CheckButtonPress(startn As Integer,endn As Integer) As Integer
Local Integer xt,yellowt,n
CheckButtonPress = -1
If Touch(x) <> -1 Then
WatchDog 1200000
xt = Touch(x)
yellowt = Touch(y)
For n = startn To endn
If xt > key_coord(n,0) And xt < key_coord(n,0) + key_coord(n,2) And yellowt > key_coord(n,1) And yellowt < key_coord(n,1) + key_coord(n,3) Then
DrawButton n,2
CheckButtonPress = n
Exit For
EndIf
Next n
EndIf
End Function
Sub CheckButtonRelease n As Integer
Do While Touch(x) <> -1 : Loop
DrawButton n,1
End Sub
Sub MessageBox s1 As String,s2 As String
Local Integer w
If Len(s1) > Len(s2) Then w = Len(s1) Else w = Len(s2)
w = w * 8
RBox MM.HRes/2 - w - 20,60,w * 2 + 40,130,,c.entry,0
Text MM.HRes/2,70,s1,CT,1,2,RGB(white)
Text MM.HRes/2,100,s2,CT,1,2,RGB(white)
RBox 110,140,100,34,,c.button
Text MM.HRes/2,157,"OK",CM,1,2,c.button
WatchDog 1200000
Do While Not (Touch(x) > 110 And Touch(x) < 210 And Touch(y) > 140 And Touch(y)
 < 180) : Loop
RBox 110,140,100,34,,c.button,c.button
Text MM.HRes/2,157,"OK",CM,1,2,0,c.button
Do While Touch(x) <> -1 : Loop
End Sub
DefineFont #2
5F202018 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00001800 3C00003C 003C0000 00003C00 3C00003C 001C0000 00001C00
18000018 00180000 00001800 18000018 00180000 00001800 00000018 00000000
00000000 3C000018 003C0000 00003C00 00000000 00000000 00000000 00000000
00000000 0180C000 E101E0E1 E0F101E0 00E0E000 E000E060 C0C100C0 03808101
00000003 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 E10080E1 80C10080 0080C300 C30080C3 F0FF0F00 01F0FF1F
C30100C3 00830100 01008701 86010087 E0FF1F00 01E0FF1F 86030086 00060300
03000603 0E03000E 000C0300 00000000 00000000 00000000 00000000 00000000
00000000 00000000 18000018 00FE0000 0380FF01 1807E09B 801807C0 07001807
98030018 00F80300 0000FC00 1F00007F C01900C0 00E01800 18006018 60180460
0FE01806 FF03C019 00FF0180 00001800 18000018 00000000 00000000 00000000
00000000 01000000 E00700C0 60700770 0CE0300E 310CC030 80330E80 07007306
C60300E7 000E0000 00000C00 1800001C 00300000 00E07100 E600F063 18C60038
0118C601 86031886 F0030338 00E00106 00000000 00000000 00000000 00000000
00000000 01002000 FE0300FC 008E0300 07000603 06030007 00860300 01008E03
F80000DC 00F00000 0700F003 1C0740B8 701C0E60 0CE00E0E 031CC007 80030CC0
0FC0070E FC07E01E 60F803F0 00000000 00000000 00000000 00000000 00000000
00000000 00001800 3C00003C 003C0000 00001C00 1800000C 00180000 00003000
00000060 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000100 0F000007 001C0080 00003800 70000070 00E00000 0100C000
C00100C0 00800100 03008001 80030080 00800300 03008003 80010080 00800100
0100C001 E00000C0 00E00000 00007000 38000078 001C0000 00000F00 03008007
00000000 00008000 F00000E0 00780000 00001C00 0700000E 00070000 00800300
01008003 C00100C0 00C00000 0000C000 E00000C0 00E00000 0000C000 C00100C0
00C00100 03008001 80030080 00000700 1E00000E 003C0000 00007800 C00000F0
00800000 00000000 00000000 00000000 00000000 1C000000 001C0000 04001C00
1807101C F0C90770 00C0FF01 3C00003C 00760000 00006300 C10180E3 C08103C0
00808000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 1C00001C 001C0000 00001C00
1C00001C 001C0000 07F0FF07 1C00F0FF 001C0000 00001C00 1C00001C 001C0000
00001C00 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00060000
00000F00 0F00000F 00070000 00000300 06000006 000C0000 00001800 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 03E0FF03 0000E0FF 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000C00 1E00001E 001E0000 00000000 00000000 00000000 00000000 00000000
00000000 00400000 0000E000 C00000E0 00C00100 03008001 00030080 00000700
0E000007 000E0000 00001C00 3800001C 00380000 00003000 60000070 00E00000
0100C000 800100C0 00800300 07008003 00010000 00000000 00000000 00000000
00000000 00001000 FE00007C 00C70100 03808303 01078001 C00107C0 06C00006
000EC000 E0000EE0 0EE0000E 000EE000 C00006E0 06C00006 0107C000 800103C0
01808303 FE0000C7 007C0000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 3E00000E 00FE0100 0000C600 06000006 00060000 00000600
06000006 00060000 00000600 06000006 00060000 00000600 06000006 00060000
00000600 06000006 00060000 00000000 00000000 00000000 00000000 00000000
00000000 00001000 FF0100FE 80870300 02C00107 0100C001 C00000C0 00C00100
0300C001 80030080 00000700 1C00000E 00380000 00007000 C00100E0 00800300
07008003 FF072000 C0FF07C0 00000000 00000000 00000000 00000000 00000000
00000000 00000000 FF0300FC 00070700 00800302 01008001 80010080 00800300
1E000007 007C0000 00007F00 03008007 C0010080 00C00100 0100C001 C00102C0
07800302 FF038087 00FC0100 00000000 00000000 00000000 00000000 00000000
00000000 00000000 0F000007 000F0000 00001F00 3700003F 00670000 00006700
C70100C7 00870100 07000703 07060007 E0FF0F00 0FE0FF0F 0700E0FF 00070000
00000700 07000007 00070000 00000000 00000000 00000000 00000000 00000000
00000000 03000000 FF03C0FF 000003C0 03000003 00030000 00000300 07000007
FF0700FE 80870700 00C00107 0000C001 E00000C0 00E00000 0000E000 C00102C0
07C0010E FF038087 00FE0100 00000000 00000000 00000000 00000000 00000000
00000000 00000800 FF00007F 80C101C0 03808003 00070000 00000700 06000006
FF06003E 80C70700 07808107 0006C001 C00006C0 06C00006 0007C000 C00103C0
01C08103 FF0080C3 007E0000 00000000 00000000 00000000 00000000 00000000
00000000 07000000 FF07C0FF C00100C0 00800300 03008003 00070000 00000700
0E00000E 000C0000 00001C00 3800001C 00380000 00003800 70000070 00700000
0000E000 E00000E0 00C00100 00000000 00000000 00000000 00000000 00000000
00000000 00001800 FF0100FE 80830300 07800103 0107C001 C00103C0 01808303
FE0000C7 007C0000 0300FF01 030780C7 C0010780 0EC00006 000EE000 C00006C0
07C00107 FF038083 00FE0080 00000000 00000000 00000000 00000000 00000000
00000000 00001000 FF0100FE 80870300 07800307 0106C001 C00006C0 06C00006
0007C000 C00107C0 03C08303 FC00C0FE C02000C0 00C00100 0100C001 800300C0
03800302 FE07000F 00F80100 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00180000 00003C00 3C00003C 00000000 00000000
00000000 00000000 00000000 00000000 00180000 00003C00 3C00003C 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 000C0000 00001E00 1E00001E 00000000 00000000
00000000 00000000 00000000 00000000 000C0000 00001E00 1E00001E 000E0000
00000600 0C00000C 00180000 00003000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00200000 0300E000 800F00E0 00003E00
E00300F8 00800F00 1E00001E 800F0000 00E00300 0000F000 1F00007C C0070000
00E00100 0000E000 00000020 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 F0FF0700 00F0FF07
00000000 00000000 00000000 FF070000 F0FF07F0 00F0FF07 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 0E000008 800F0000 00E00300 0000F800
0F00003E C0030000 00E00000 0300E000 800F00C0 00003E00 F0010078 00C00700
1C00001F 00180000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 FF00003E C0FF0180 03C08107 0001E000 E00000E0 00E00000
0100E000 C00300E0 00800700 0E000007 000C0000 00000C00 1C00001C 00000000
00000000 0C000000 001E0000 00001E00 0000001E 00000000 00000000 00000000
00000000 00000000 FF00001C 80E70100 07C08103 0006E000 60000E60 0CE0030C
3C1CE01F 60701C60 18606018 601C6060 E0701C60 0CE0791C 0E0CE03F 00000E00
03000007 C0030080 C0FF00C0 00807F00 00000000 00000000 00000000 00000000
00000000 00002000 30000030 00300000 00007800 78000078 00FC0000 0000CC00
860100CE 00860100 03008701 03030003 80FF0380 0680FF07 010EC001 C0000EC0
1CE0000C 001CE000 70001870 00000000 00000000 00000000 00000000 00000000
00000000 0F000000 FF0F00FE 80070C00 0CC0010C 000CC001 C0010CC0 0CC0010C
FF0F8003 00FE0F00 0C80FF0F 010CC003 E0000CC0 0CE0000C 000CE000 E0000CE0
0CC0010C FF0FC007 00FC0F80 00000000 00000000 00000000 00000000 00000000
00000000 00000800 FF01007F E0C103C0 07E08007 000E7000 00000E00 0C00000E
000C0000 00000C00 0C00000C 000C0000 00000C00 0E00000E 00070000 40000700
03E08003 FF00C0C1 007F0080 00000000 00000000 00000000 00000000 00000000
00000000 0F000000 FF0F00FC 800F0C00 0C80030C 010CC001 E0000CC0 0CE0000C
000CE000 E0000CE0 0C60000C 000C6000 E0000CE0 0CE0000C 010CC000 C0010CC0
0C80030C FE0F000F 00F80F00 00000000 00000000 00000000 00000000 00000000
00000000 0F000000 FF0FE0FF 00000EE0 0E00000E 000E0000 00000E00 0E00000E
000E0000 00FF0F00 0E00FF0F 000E0000 00000E00 0E00000E 000E0000 00000E00
0E00000E FF0F0000 C0FF0FC0 00000000 00000000 00000000 00000000 00000000
00000000 07000000 FF07C0FF 000007C0 07000007 00070000 00000700 07000007
FF070000 00FF0700 0700FF07 00070000 00000700 07000007 00070000 00000700
07000007 00070000 00000700 00000000 00000000 00000000 00000000 00000000
00000000 00000400 FF00807F E0E001C0 03708003 00072080 00000700 06000006
00060000 00000E00 0E00000E 030EF003 300006F0 07300006 00073000 30800330
0130C003 FF00F0E0 803F00E0 00000000 00000000 00000000 00000000 00000000
00000000 0E000000 000EE000 E0000EE0 0EE0000E 000EE000 E0000EE0 0EE0000E
000EE000 E0FF0FE0 0EE0FF0F 000EE000 E0000EE0 0EE0000E 000EE000 E0000EE0
0EE0000E 000EE000 E0000EE0 00000000 00000000 00000000 00000000 00000000
00000000 07000000 FF0780FF 00300080 00003000 30000030 00300000 00003000
30000030 00300000 00003000 30000030 00300000 00003000 30000030 00300000
00003000 FF070030 80FF0780 00000000 00000000 00000000 00000000 00000000
00000000 00000000 FF00E0FF 000700E0 00000700 07000007 00070000 00000700
07000007 00070000 00000700 07000007 00070000 00000700 06000006 000E0000
0F000E04 F807001C 00F80300 00000000 00000000 00000000 00000000 00000000
00000000 0CA00002 030CC001 80070C80 0C00070C 1C0C000E 00380C00 0C00700C
C00D00E0 00E00F00 0E00E00F 380C0070 003C0C00 0C001C0C 0F0C000E 00070C00
0C80030C 010CC001 F0000CE0 00000000 00000000 00000000 00000000 00000000
00000000 07000000 00070000 00000700 07000007 00070000 00000700 07000007
00070000 00000700 07000007 00070000 00000700 07000007 00070000 00000700
07000007 FF070000 E0FF07E0 00000000 00000000 00000000 00000000 00000000
00000000 0C000000 000E6000 E0000EE0 0FE0010F 830FE001 60830FE0 0C60C70D
EE0C60C6 606C0C60 0C60780C 300C6038 60100C60 0C60000C 000C6000 60000C60
0C60000C 000C6000 60000C60 00000000 00000000 00000000 00000000 00000000
00000000 0E000000 000EE000 E0000FE0 0FE0800F C00DE080 E0C00DE0 0CE0E00C
700CE060 E0380CE0 0CE0380C 1C0CE01C E00E0CE0 0CE00E0C 030CE007 E0030CE0
0CE0010C 000CE001 E0000CE0 00000000 00000000 00000000 00000000 00000000
00000000 00000000 FF0100FE 80830380 0EC00107 000EC000 E0000CE0 1C60001C
001C6000 70001C70 1C70001C 001C7000 60001C70 0E60000C 000EE000 C00107E0
03C08107 FF0180C7 00FE0000 00000000 00000000 00000000 00000000 00000000
00000000 0F000000 FF0F00FF C0030E80 0EC0010E 000EE000 E0000EE0 0EE0000E
010EE000 80FF0FC0 0F00FF0F 000E00FC 00000E00 0E00000E 000E0000 00000E00
0E00000E 000E0000 00000E00 00000000 00000000 00000000 00000000 00000000
00000000 00000800 FF00007F C0C101C0 07E08003 00076000 70000670 0E30000E
000E3000 38000E38 0E38000E 000E3800 30000E38 07300006 00073000 60000370
01E08003 FF00C0E3 007E0080 00001C00 0E00000C F00F0000 00F00700 00000000
00000000 0F000000 FF0F00FF C0030E80 0EC0010E 000EE000 E0000EE0 0EE0000E
030EC001 80FF0FC0 0F00FF0F 0C0E00FC 000E0E00 0E00070E 030E0007 80030E80
0EC0010E 000EC001 E0000EE0 00000000 00000000 00000000 00000000 00000000
00000000 00000000 FF00807F E0C001C0 03608003 80034080 00800300 01008003
F80000E0 007E0000 00801F00 0100C007 F00000E0 00700000 00007000 70000270
07E00007 FF01E0C1 00FF00C0 00000000 00000000 00000000 00000000 00000000
00000000 0F000000 FF0FF0FF 001800F0 00001800 18000018 00180000 00001800
18000018 00180000 00001800 18000018 00180000 00001800 18000018 00180000
00001800 18000018 00180000 00000000 00000000 00000000 00000000 00000000
00000000 0E000000 000C6000 60000C60 0C60000C 000C6000 60000C60 0C60000C
000C6000 60000C60 0C60000C 000C6000 60000C60 0E60000C 000EE000 E0000EE0
07C00107 FF03C083 00FE0080 00000000 00000000 00000000 00000000 00000000
00000000 1C000000 000C7000 E0000E60 06E0000E 0107C000 C00107C0 03800103
83038081 00830180 0100C301 C60000C7 00E60000 0000EE00 7C00006C 007C0000
00003800 38000038 00100000 00000000 00000000 00000000 00000000 00000000
00000000 18000000 10183000 30101C30 1C30181C 380C7018 603C0C60 0C603C0C
6C0E606C 606E0E60 06C06606 C606C0C6 C0C706C0 07C08307 8307C083 80830380
03800103 01038001 80010380 00000000 00000000 00000000 00000000 00000000
00000000 0E200000 0107C000 800107C0 03808303 C7010083 00CE0100 0000EE00
7C00007C 00380000 00003800 7C00007C 00EE0000 0100CE00 830300C7 80830380
07C00107 000EC001 F0000EE0 00000000 00000000 00000000 00000000 00000000
00000000 0F080000 00073000 60800370 01E08003 C101C0C0 C0E100C0 0080E300
77008073 003F0000 00003E00 1C00001E 001C0000 00001C00 1C00001C 001C0000
00001C00 1C00001C 001C0000 00000000 00000000 00000000 00000000 00000000
00000000 0F000000 FF0FE0FF C00100E0 00C00100 03008003 00070000 00000E00
1C00000E 00380000 00003800 70000070 00E00000 0100C001 800300C0 00800300
0E000007 FF0F1000 E0FF0FE0 00000000 00000000 00000000 00000000 00000000
00000000 03000000 FF0380FF 00000380 03000003 00030000 00000300 03000003
00030000 00000300 03000003 00030000 00000300 03000003 00030000 00000300
03000003 00030000 00000300 03000003 00030000 80FF0300 0080FF03 00000000
00000000 03008000 C0010080 00C00100 0000E000 700000E0 00700000 00003800
18000038 001C0000 00000C00 0600000E 00070000 00000700 03008003 C0010080
00C00100 0000E000 600000E0 00700000 00003000 00000020 00000000 00000000
00000000 01000000 FF01C0FF C00100C0 00C00100 0100C001 C00100C0 00C00100
0100C001 C00100C0 00C00100 0100C001 C00100C0 00C00100 0100C001 C00100C0
00C00100 0100C001 C00100C0 00C00100 0100C001 C0FF01C0 00C0FF01 00000000
00000000 00000000 1C000008 001E0000 00003E00 63000077 80E30000 0180C100
8003C081 00000080 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 0FF0FF0F 0000F0FF 00000000 00000000 00000000
00000000 00000000 FE00003C 00C70100 01008301 83018083 00830180 0000C701
7C0000FE 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00080000 03007F00
8101C0FF E00001E0 00600000 00006000 E03F0060 03E0FF01 000760C0 60000760
07E00007 8307E001 60FF03E0 0060FC01 00000000 00000000 00000000 00000000
00000000 07000000 00070000 00000700 07000007 00070000 00040700 07003F07
C107C07F E08007C0 07F00007 00077000 70000770 07700007 00077000 70000770
07E08007 C307E080 807F07C0 00003F06 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 0300FF00
830780FF 800007C0 0C80000E 001C0000 00001C00 1C00001C 001C0000 00000E00
0700000E C3078001 80FF03C0 0000FE00 00000000 00000000 00000000 00000000
00000000 00000000 0000C000 C00000C0 00C00000 0000C000 C02000C0 03C0FC01
8307C0FE C00107C0 0EC0010E 000EC001 C0000CC0 0EC0000C 010EC000 C0010EC0
07C0010E 8707C003 C0FE03C0 00E0FC00 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00100000 0100FE00
830300FF C0010780 0EC00006 000EC000 E0FF0FE0 0EE0FF0F 000E0000 00000E00
07000006 C1038000 80FF01C0 0000FF00 00000000 00000000 00000000 00000000
00000000 00000000 3F00C00F 707800E0 00207000 E00020E0 00E00000 0000E000
FF0F00E0 00FF0F00 0000E000 E00000E0 00E00000 0000E000 E00000E0 00E00000
0000E000 E00000E0 00E00000 0000E000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 01203000
DF03F0FC 000707F0 0E000306 030E8003 00030680 07000707 FE03008F 00F80300
06000007 00070000 00FF0700 06C0FF03 000CE001 60000CE0 0EE0001C FF0FC001
00FF0380 07000000 00060000 00000600 06000006 00060000 00000600 06000406
7F06003F C0C30680 07C08107 0007C001 C00006C0 06C00006 0006C000 C00006C0
06C00006 0006C000 C00006C0 00C00006 00000000 00000000 00000000 00000000
00000000 00001000 38000038 00380000 00000000 00000000 00000000 0300F803
380000F8 00380000 00003800 38000038 00380000 00003800 38000038 00380000
00003800 38000038 80FF0300 0080FF03 00000000 00000000 00000000 00000000
00000000 00000000 01008000 C00100C0 00C00100 00000000 00000000 00000000
7F00C07F C00100C0 00C00100 0100C001 C00100C0 00C00100 0100C001 C00100C0
00C00100 0100C001 C00100C0 00C00100 0100C001 800301C0 03808703 FE0000FF
00100000 0F000000 000E0000 00000E00 0E00000E 000E0000 00000E00 0E00000E
030EE001 00070E80 0E000E0E 380E001C 00700E00 0F00F00F 3C0F00B8 001E0E00
0E000E0E 030E0007 C0030E80 00E0010E 00000000 00000000 00000000 00000000
00000000 07000000 F80700F8 00380000 00003800 38000038 00380000 00003800
38000038 00380000 00003800 38000038 00380000 00003800 38000038 00380000
00003800 38000038 C0FF0F00 00C0FF0F 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 40200000 0FF0F90E
1E0F70FB 381C0E30 0E381C0E 1C0E381C 381C0E38 0E381C0E 1C0E381C 381C0E38
0E381C0E 1C0E381C 381C0E38 00381C0E 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00040000 03801F03
6103C03F E0C003E0 03E08003 0003E080 60000360 03600003 00036000 60000360
03600003 00036000 60000360 00600003 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00100000 0100FE00
830300FF C0010780 0EE0010E 000EE000 E0000CE0 0E60000C 000EE000 E0000EE0
07E0000F 8303C001 00FF0180 0000FE00 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00080000 0E007F0E
830F80FF C0010FC0 0EE0000E 000EE000 E0000EE0 0E60000E 000EE000 E0000EE0
0FE0000E 830FC001 80FF0E80 0E007E0E 000E0000 00000E00 0E00000E 000E0000
00000000 00000000 00000000 00000000 00000000 00000000 00080000 01707E00
C10370FF F08003F0 07F00007 00077000 70000670 07700006 00077000 F0000770
03F00007 C303F081 70FF01F0 00707E00 00007000 70000070 00700000 00007000
00000070 00000000 00000000 00000000 00000000 00000000 00040000 06803F07
E006C07F 80C007C0 07008007 00070000 00000700 06000006 00060000 00000600
06000006 00060000 00000600 00000006 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00100000 0100FF00
810380FF 800007C0 03800007 E0030080 00FC0100 00007F00 0300C00F C00100C0
06C00004 830FC001 80FF03C0 0000FE01 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00700000 00007000 60000070 00600000 0780FF07
600080FF 00600000 00006000 E00000E0 00E00000 0000E000 E00000E0 00E00000
0000E000 78004070 E07F00C0 00803F00 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 0EC0000E
000EC000 C0000EC0 0EC0000E 000EC000 C0000EC0 0EC0000E 000EC000 C0010EC0
07C00107 8707C003 C0FC03C0 00E0F801 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000800 07300007
00037000 60800360 01E08003 C001C0C0 C0C101C0 0080E100 630080E3 00770000
00007600 3E00003E 001C0000 00003C00 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 18300018
38183010 60381C70 0C60380C 6C0C603C 606C0C60 06606C0E C6064066 C0C606C0
07C0C707 8303C083 808303C0 00808103 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 03E00007
C101C081 80C301C0 0000E700 3E000077 003C0000 00001C00 7E00003E 00770000
0180E300 8101C0C1 E08003C0 00700007 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 0EE0000E
0007E000 C00007C0 03C00103 81038081 80C30180 0000C301 E70000C7 00E60000
00007E00 3C00007C 003C0000 00003800 30000038 00700000 1F006008 C00F00E0
00000200 00000000 00000000 00000000 00000000 00000000 00000000 07C0FF07
0300C0FF 80070080 00000700 1C00000E 00380000 00007800 E0000070 00C00100
07008003 000F0080 E0FF0F20 00E0FF0F 00000000 00000000 00000000 00000000
00000000 00000000 1F00C007 003C00C0 00003000 70000070 00700000 00007000
70000070 00700000 00006000 C00700E0 00800700 0000C003 600000E0 00700000
00007000 70000070 00700000 00007000 70000070 00780000 00003C00 0700C01F
000000C0 00000000 1C00001C 001C0000 00001C00 1C00001C 001C0000 00001C00
1C00001C 001C0000 00001C00 1C00001C 001C0000 00001C00 1C00001C 001C0000
00001C00 1C00001C 001C0000 00001C00 1C00001C 001C0000 00001C00 1C00001C
00000000 01000000 FE0100F8 000F0000 00000700 03000003 80030080 00800300
03008003 80030080 00800300 0000C001 780000F8 00E00000 03008001 80030080
00800300 03008003 80030080 00800300 03008003 00070080 01000F00 F80100FE
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 03000000 F80720E0 E03F0E70 00C00F0C 00000007 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000
End DefineFont
DefineFont #3
0A306440 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 3F000000 000000F8 FF010000 000000FF FF070000 0000C0FF FF0F0000
0000F0FF FF1F0000 0000F8FF FF7F0000 0000FCFF FFFF0000 0000FEFF FFFF0100
0000FFFF FFFF0300 0080FFFF F8FF0700 0080FF1F C0FF0F00 00C0FF03 80FF0F00
00E0FF01 00FF1F00 00F0FF00 00FE1F00 00F07F00 00FC3F00 00F83F00 00F83F00
00F81F00 00F87F00 00FC0F00 00F07F00 00FC0F00 00F0FF00 00FE0F00 00E0FF00
00FE0700 00E0FF00 00FE0700 00C0FF00 00FF0300 00C0FF01 00FF0300 00C0FF01
00FF0300 00C0FF01 80FF0300 0080FF03 80FF0100 0080FF03 C0FF0100 0000FF03
C0FF0000 0000FF03 C0FF0000 0000FF03 C0FF0000 0000FF07 E0FF0000 0000FF07
E0FF0000 0000FE07 E07F0000 0000FE07 E07F0000 0000FE0F F07F0000 0000FE0F
F07F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F
F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F
F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F
F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F
F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 0000FC0F
F03F0000 0000FE0F F07F0000 0000FE0F F07F0000 0000FE07 E07F0000 0000FE07
E07F0000 0000FF07 E07F0000 0000FF07 E0FF0000 0000FF03 C0FF0000 0000FF03
C0FF0000 0080FF03 C0FF0000 0080FF01 80FF0100 0080FF01 80FF0100 0080FF01
80FF0100 00C0FF00 80FF0300 00C0FF00 00FF0300 00C0FF00 00FF0300 00C0FF00
00FF0300 00E07F00 00FE0700 00F03F00 00FE0F00 00F03F00 00FC0F00 00F83F00
00FC1F00 00FC1F00 00F83F00 00FE0F00 00F87F00 00FF0F00 00F0FF00 80FF0700
00E0FF01 C0FF0700 00E0FF03 F0FF0300 00C0FF07 FCFF0100 0080FF1F FFFF0000
0000FFFF FFFF0000 0000FEFF FF7F0000 0000FCFF FF3F0000 0000F8FF FF1F0000
0000E0FF FF070000 0000C0FF FF010000 000080FF 7F000000 000000FE 1F000000
000000F8 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 000000FF 01000000
000000FF 03000000 000000FF 07000000 000000FF 0F000000 000000FF 1F000000
000000FF 3F000000 000000FF 7F000000 000000FF FF000000 000000FF FF010000
000000FF FF030000 000000FF FF070000 000000FF FF0F0000 000000FF FF1F0000
000000FF FF7F0000 000000FF FFFF0000 000000FF FFFF0300 000000FF FBFF0700
000000FF F3FF0F00 000000FF C3FF3F00 000000FF 83FFFF00 000000FF 03FEFF00
000000FF 03FCFF00 000000FF 03F8FF00 000000FF 03E0FF00 000000FF 03C0FF00
000000FF 0300FF00 000000FF 0300FE00 000000FF 0300F800 000000FF 0300E000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 03000000 000000FF 03000000 000000FF 03000000 000000FF 03000000
000000FF 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 FF000000 000000FC FF070000 000080FF FF1F0000 0000F0FF FF7F0000
0000FCFF FFFF0100 0000FEFF FFFF0300 0080FFFF FFFF0700 00E0FFFF FFFF0F00
00F0FFFF FFFF1F00 00F8FFFF E0FF1F00 00FCFF07 00FF3F00 00FEFF01 00FC7F00
00FF7F00 00F0FF00 00FF1F00 00E0FF00 00FF0F00 00C0FF01 80FF0700 0080FF01
80FF0300 0080FF03 C0FF0100 0000FF03 C0FF0000 0000FF07 C0FF0000 0000FE07
E0FF0000 0000FE0F E07F0000 0000FE0F E07F0000 0000FC0F E07F0000 0000FC0F
F03F0000 0000FC0F F03F0000 0000FC0F F03F0000 00000000 F03F0000 00000000
F03F0000 00000000 F03F0000 00000000 F03F0000 00000000 F03F0000 00000000
F03F0000 00000000 E07F0000 00000000 E07F0000 00000000 E0FF0000 00000000
C0FF0100 00000000 C0FF0300 00000000 80FF0700 00000000 80FF0F00 00000000
00FF1F00 00000000 00FF3F00 00000000 00FE7F00 00000000 00FCFF00 00000000
00F8FF01 00000000 00F0FF03 00000000 00E0FF07 00000000 00C0FF0F 00000000
0080FF1F 00000000 0000FF3F 00000000 0000FE7F 00000000 0000FCFF 01000000
0000F8FF 03000000 0000F0FF 07000000 0000E0FF 0F000000 0000C0FF 1F000000
000080FF 3F000000 000000FF 7F000000 000000FE FF000000 000000FC FF010000
000000F8 FF030000 000000F0 FF070000 000000E0 FF0F0000 000000C0 FF1F0000
00000080 FF3F0000 00000000 FE7F0000 00000000 FCFF0000 00000000 F8FF0100
00000000 F0FF0300 00000000 E0FF0700 00000000 C0FF0F00 00000000 80FF1F00
00000000 00FF3F00 00000000 00FE3F00 00000000 00FC7F00 00000000 00F8FF00
00000000 00F0FF01 00000000 00E0FF01 00000000 00E0FF03 00000000 00C0FF03
00000000 00C0FF07 00000000 00C0FF07 00000000 FFFFFF0F F0FFFFFF FFFFFF0F
F0FFFFFF FFFFFF1F F0FFFFFF FFFFFF1F F0FFFFFF FFFFFF3F F0FFFFFF FFFFFF3F
F0FFFFFF FFFFFF3F F0FFFFFF FFFFFF3F F0FFFFFF FFFFFF3F F0FFFFFF FFFFFF3F
F0FFFFFF 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 1F000000 000000F0 FF010000 000000FF FF0F0000 0000E0FF FF3F0000
0000F0FF FFFF0000 0000F8FF FFFF0100 0000FEFF FFFF0300 0000FFFF FFFF0700
0080FFFF FFFF0F00 00C0FFFF C0FF0F00 00E0FF0F 00FE1F00 00F0FF03 00FC1F00
00F0FF00 00F03F00 00F87F00 00E07F00 00F83F00 00E07F00 00FC1F00 00C07F00
00FC0F00 00C0FF00 00FE0F00 0080FF00 00FE0700 0080FF01 00FE0700 0000FF01
00FE0700 0000FF01 00FE0300 0000FF01 00FF0300 0000FF01 00FF0300 0000FF01
00FF0300 00000000 00FF0300 00000000 00FF0300 00000000 00FE0700 00000000
00FE0700 00000000 00FE0F00 00000000 00FC0F00 00000000 00FC1F00 00000000
00F81F00 00000000 00F03F00 00000000 00F07F00 00000000 00E0FF00 00000000
00E0FF01 00000000 00C0FF07 00000000 0080FF1F 3F000000 0000FFFF 3F000000
0000FFFF 3F000000 0000FEFF 3F000000 0000FEFF 3F000000 0000FEFF 3F000000
0000FFFF 3F000000 00C0FFFF 3F000000 00E0FFFF 00000000 00F0FF03 00000000
00F8FF00 00000000 00FC3F00 00000000 00FC1F00 00000000 00FE0700 00000000
00FE0700 00000000 00FF0300 00000000 00FF0100 00000000 80FF0100 00000000
80FF0000 00000000 C0FF0000 00000000 C07F0000 00000000 C07F0000 00000000
E03F0000 00000000 E03F0000 00000000 E03F0000 00000000 F01F0000 00000000
F01F0000 00000000 F01F0000 00000000 F01F0000 0000FE03 F01F0000 0000FE03
F01F0000 0000FE03 E01F0000 0000FE03 E03F0000 0000FF03 E03F0000 0000FF03
E03F0000 0000FF03 C07F0000 0080FF01 C0FF0000 0080FF01 C0FF0000 00C0FF01
80FF0100 00C0FF00 80FF0100 00E0FF00 00FF0300 00E07F00 00FF0700 00F07F00
00FE0F00 00F83F00 00FC3F00 00FE3F00 00F8FF00 80FF1F00 00F8FF03 E0FF0F00
00F0FF0F FFFF0700 00E0FFFF FFFF0300 00C0FFFF FFFF0100 0080FFFF FFFF0000
0000FEFF FF7F0000 0000FCFF FF1F0000 0000E0FF FF070000 000000FF 7F000000
000000F0 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 0000FF00 00000000 0000FF01 00000000 0000FF03 00000000
0000FF03 00000000 0000FF07 00000000 0000FF07 00000000 0000FF0F 00000000
0000FF0F 00000000 0000FF1F 00000000 0000FF3F 00000000 0000FF3F 00000000
0000FF7F 00000000 0000FFFF 00000000 0000FFFF 01000000 0000FFFF 01000000
0000FFFF 03000000 0000FFFF 07000000 0000FFFF 07000000 0000FFFF 0F000000
0000FFFF 0F000000 0000FFFF 1F000000 0000FFFF 3F000000 0000FFFB 3F000000
0000FFF3 7F000000 0000FFF3 FF000000 0000FFE3 FF000000 0000FFC3 FF010000
0000FFC3 FF030000 0000FF83 FF030000 0000FF83 FF070000 0000FF03 FE070000
0000FF03 FE0F0000 0000FF03 FC1F0000 0000FF03 FC1F0000 0000FF03 F83F0000
0000FF03 F07F0000 0000FF03 F07F0000 0000FF03 E0FF0000 0000FF03 C0FF0000
0000FF03 C0FF0100 0000FF03 80FF0300 0000FF03 00FF0300 0000FF03 00FF0700
0000FF03 00FE0700 0000FF03 00FC0F00 0000FF03 00FC1F00 0000FF03 00F81F00
0000FF03 00F83F00 0000FF03 00F03F00 0000FF03 00E07F00 0000FF03 00E07F00
0000FF03 00C0FF00 0000FF03 00C0FF01 0000FF03 0080FF01 0000FF03 0000FF03
0000FF03 0000FE07 0000FF03 0000FE07 0000FF03 0000FC07 0000FF03 0000FC0F
0000FF03 FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F
F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F
F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF 00000000 0000FF03 00000000
0000FF03 00000000 0000FF03 00000000 0000FF03 00000000 0000FF03 00000000
0000FF03 00000000 0000FF03 00000000 0000FF03 00000000 0000FF03 00000000
0000FF03 00000000 0000FF03 00000000 0000FF03 00000000 0000FF03 00000000
0000FF03 00000000 0000FF03 00000000 0000FF03 00000000 0000FF03 00000000
0000FF03 00000000 0000FF03 00000000 0000FF03 00000000 0000FF03 00000000
0000FF03 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 FFFF0100 00FFFFFF FFFF0100 00FFFFFF FFFF0100 00FFFFFF FFFF0300
00FFFFFF FFFF0300 00FFFFFF FFFF0300 00FFFFFF FFFF0700 00FFFFFF FFFF0700
00FFFFFF FFFF0700 00FFFFFF FFFF0700 00FFFFFF 00FC0F00 00000000 00FC0F00
00000000 00FC0F00 00000000 00F80F00 00000000 00F80F00 00000000 00F81F00
00000000 00F01F00 00000000 00F01F00 00000000 00F03F00 00000000 00F03F00
00000000 00F03F00 00000000 00F03F00 00000000 00F03F00 00000000 00E03F00
00000000 00E07F00 00000000 00E07F00 00000000 00E07F00 00000000 00E07F00
00000000 00C0FF00 00000000 00C0FF00 00000000 01C0FF00 000000FF 07C0FF00
0000F0FF 7F80FF00 0000FCFF FF81FF00 0000FFFF FF87FF00 0080FFFF FF9FFF00
00E0FFFF FFFFFF00 00F0FFFF FFFFFF01 00F8FFFF FFFFFF01 00FCFFFF FFFFFF01
00FCFF00 F8FFFF01 00FE3F00 C0FFFF01 00FF0F00 00FFFF03 00FF0700 00FCFF03
80FF0300 00F8FF03 80FF0100 00E0FF03 80FF0000 0080FF03 C0FF0000 0000FF03
C07F0000 00000000 C07F0000 00000000 C07F0000 00000000 E03F0000 00000000
E03F0000 00000000 E03F0000 00000000 E03F0000 00000000 F01F0000 00000000
F01F0000 00000000 F01F0000 00000000 F01F0000 00000000 F01F0000 00000000
F01F0000 00000000 F01F0000 00000000 F01F0000 00000000 F01F0000 00000000
F03F0000 00000000 E03F0000 00000000 E03F0000 0000FC0F E03F0000 0000FC0F
E07F0000 0000FC0F C07F0000 0000FC0F C07F0000 0000FE0F C07F0000 0000FE07
C0FF0000 0000FE07 80FF0000 0000FF07 80FF0100 0000FF07 00FF0300 0080FF03
00FF0700 00C0FF03 00FF0F00 00C0FF03 00FE1F00 00E0FF01 00FE3F00 00F0FF00
00FC7F00 00FCFF00 00F8FF01 00FE7F00 00F0FF07 C0FF3F00 00E0FF1F FFFF1F00
00C0FFFF FFFF0F00 0080FFFF FFFF0700 0000FFFF FFFF0300 0000FEFF FFFF0100
0000F8FF FF7F0000 0000F0FF FF1F0000 0000C0FF FF010000 000000FC 1F000000
000000E0 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 3F000000 000000FC FF030000 0000C0FF FF0F0000 0000F8FF FF3F0000
0000FEFF FFFF0000 0000FFFF FFFF0100 0080FFFF FFFF0300 00C0FFFF FFFF0700
00E0FFFF FCFF0F00 00F0FF0F E0FF1F00 00F8FF00 00FF3F00 00FC7F00 00FC3F00
00FE1F00 00F87F00 00FE0F00 00F07F00 00FF0700 00E0FF00 00FF0300 00C0FF00
80FF0100 00C0FF01 80FF0000 0080FF01 C0FF0000 0080FF03 C07F0000 0080FF03
C07F0000 0000FF03 C03F0000 0000FF03 C03F0000 0000FF03 00000000 0000FF03
00000000 0000FE07 00000000 0000FE07 00000000 0000FE07 00000000 0000FE07
00000000 0000FE07 00000000 0000FC07 00000000 0000FC0F 00000000 0000FC0F
00000000 0700FC0F 000000FC 7F00FC0F 000080FF FF01FC0F 0000F0FF FF07FC0F
0000FEFF FF1FFC0F 0000FFFF FF7FFC0F 00C0FFFF FFFFFC0F 00E0FFFF FFFFFF0F
00F0FFFF FFFFFF0F 00F8FFFF F8FFFF0F 00FCFF07 C0FFFF0F 00FEFF00 80FFFF0F
00FE3F00 00FEFF0F 00FF0F00 00FCFF0F 00FF0300 00F0FF0F 80FF0100 00E0FF0F
80FF0100 00C0FF0F 80FF0000 0080FF0F C0FF0000 0080FF0F C07F0000 0000FF0F
C07F0000 0000FF0F E07F0000 0000FE0F E03F0000 0000FE0F E03F0000 0000FC0F
E03F0000 0000FC0F E01F0000 0000FC0F F01F0000 0000FC0F F01F0000 0000FC0F
F01F0000 0000FC0F F01F0000 0000FC0F F01F0000 0000FC07 F01F0000 0000FE07
F01F0000 0000FE07 F01F0000 0000FE07 F01F0000 0000FE07 F01F0000 0000FF07
E01F0000 0000FF03 E01F0000 0080FF03 E03F0000 0080FF03 E03F0000 0080FF03
E03F0000 00C0FF01 E03F0000 00C0FF01 C07F0000 00E0FF01 C0FF0000 00E0FF00
C0FF0000 00F0FF00 80FF0100 00F87F00 80FF0300 00FC3F00 80FF0700 00FE3F00
00FF1F00 00FF1F00 00FE7F00 C0FF0F00 00FCFF00 F8FF0F00 00F8FF07 FFFF0700
00F0FFFF FFFF0300 00E0FFFF FFFF0100 00C0FFFF FFFF0000 0080FFFF FF7F0000
0000FEFF FF1F0000 0000F8FF FF070000 0000E0FF FF000000 000000FF 1F000000
000000F8 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F
F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F
F0FFFFFF FFFFFF0F F0FFFFFF FFFFFF0F F0FFFFFF 00000000 F07F0000 00000000
F0FF0000 00000000 F0FF0000 00000000 E0FF0100 00000000 E0FF0300 00000000
C0FF0300 00000000 80FF0700 00000000 00FF0F00 00000000 00FE1F00 00000000
00FE3F00 00000000 00FC7F00 00000000 00F8FF00 00000000 00F0FF00 00000000
00E0FF01 00000000 00C0FF03 00000000 0080FF03 00000000 0000FF07 00000000
0000FE0F 00000000 0000FE0F 00000000 0000FC1F 00000000 0000F83F 00000000
0000F83F 00000000 0000F07F 00000000 0000F07F 00000000 0000E0FF 00000000
0000C0FF 01000000 0000C0FF 01000000 000080FF 03000000 000080FF 03000000
000000FF 07000000 000000FF 07000000 000000FF 07000000 000000FE 0F000000
000000FE 0F000000 000000FC 1F000000 000000FC 1F000000 000000FC 1F000000
000000F8 3F000000 000000F8 3F000000 000000F0 3F000000 000000F0 7F000000
000000E0 7F000000 000000E0 FF000000 000000E0 FF000000 000000E0 FF000000
000000C0 FF010000 000000C0 FF010000 000000C0 FF010000 00000080 FF030000
00000080 FF030000 00000080 FF030000 00000000 FF030000 00000000 FF070000
00000000 FF070000 00000000 FE070000 00000000 FE070000 00000000 FE0F0000
00000000 FE0F0000 00000000 FC0F0000 00000000 FC0F0000 00000000 FC1F0000
00000000 F81F0000 00000000 F81F0000 00000000 F81F0000 00000000 F81F0000
00000000 F83F0000 00000000 F03F0000 00000000 F03F0000 00000000 F03F0000
00000000 F03F0000 00000000 E03F0000 00000000 E07F0000 00000000 E07F0000
00000000 E07F0000 00000000 E07F0000 00000000 E07F0000 00000000 C0FF0000
00000000 C0FF0000 00000000 C0FF0000 00000000 C0FF0000 00000000 80FF0000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 3F000000 000000FC FF030000 0000C0FF FF1F0000 0000F8FF FF7F0000
0000FEFF FFFF0000 0080FFFF FFFF0100 00C0FFFF FFFF0300 00E0FFFF FFFF0700
00E0FFFF C0FF0F00 00F0FF03 00FF1F00 00F8FF00 00FC3F00 00FC3F00 00F83F00
00FC1F00 00F03F00 00FC0F00 00F03F00 00FC0F00 00E07F00 00FE0700 00E07F00
00FE0700 00C07F00 00FE0300 00C0FF00 00FF0300 00C0FF00 00FF0300 0080FF00
00FF0300 0080FF00 00FF0100 0080FF00 00FF0100 0080FF00 00FF0100 0080FF00
00FF0100 0080FF00 00FF0100 00C07F00 00FE0300 00C07F00 00FE0300 00C07F00
00FE0300 00E07F00 00FE0700 00F03F00 00FC0700 00F03F00 00FC0F00 00F83F00
00FC0F00 00FC1F00 00F81F00 00FE0F00 00F83F00 00FF0F00 00F03F00 80FF0700
00E0FF00 C0FF0300 00C0FF01 F0FF0100 00C0FF07 FC7F0000 0080FF1F FF3F0000
0000FEFF FF1F0000 0000F8FF FF0F0000 0000F0FF FF3F0000 0000FCFF FF7F0000
0000FEFF FFFF0100 0000FFFF FFFF0700 00C0FFFF FFFF0F00 00E0FFFF E0FF1F00
00F0FF03 00FF3F00 00FC7F00 00FC7F00 00FE3F00 00F0FF00 00FF0F00 00E0FF00
00FF0700 00C0FF01 80FF0300 0080FF01 80FF0100 0080FF03 C0FF0000 0000FF03
C0FF0000 0000FF03 C0FF0000 0000FE03 C07F0000 0000FE07 E07F0000 0000FE07
E03F0000 0000FC07 E03F0000 0000FC07 E03F0000 0000FC0F F03F0000 0000F80F
F01F0000 0000F80F F01F0000 0000F80F F01F0000 0000F80F F01F0000 0000F80F
F01F0000 0000F80F F01F0000 0000FC0F F03F0000 0000FC07 E03F0000 0000FC07
E03F0000 0000FE07 E03F0000 0000FE03 C07F0000 0000FF03 C0FF0000 0000FF03
C0FF0000 0000FF01 80FF0000 0080FF01 00FF0100 00C0FF00 00FF0300 00C0FF00
00FF0700 00F07F00 00FE0F00 00F87F00 00FC1F00 00FC3F00 00FC3F00 00FF1F00
00F8FF00 E0FF0F00 00F0FF07 FFFF0700 00E0FFFF FFFF0100 00C0FFFF FFFF0000
0000FFFF FF3F0000 0000FCFF FF0F0000 0000F0FF FF010000 000000FF 3F000000
000000F8 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000 0F000000 000000F8 FF000000 000080FF FF070000 0000F0FF FF3F0000
0000FCFF FF7F0000 0000FFFF FFFF0000 0080FFFF FFFF0300 00C0FFFF FFFF0700
00E0FFFF FFFF0F00 00F0FFFF F8FF0F00 00F8FF0F C0FF1F00 00FCFF01 00FF1F00
00FC7F00 00FC3F00 00FE3F00 00F83F00 00FE1F00 00F07F00 00FF0F00 00F07F00
00FF0700 00E0FF00 80FF0300 00C0FF00 80FF0300 00C0FF01 80FF0300 00C0FF01
C0FF0100 0080FF01 C0FF0100 0080FF01 C0FF0100 0080FF01 C0FF0000 0080FF03
E0FF0000 0000FF03 E0FF0000 0000FF03 E07F0000 0000FF03 E07F0000 0000FE03
E07F0000 0000FE03 F07F0000 0000FE03 F07F0000 0000FE03 F03F0000 0000FE03
F03F0000 0000FE03 F03F0000 0000FE03 F03F0000 0000FF03 F03F0000 0000FF03
F03F0000 0000FF01 F03F0000 0080FF01 F03F0000 0080FF01 F07F0000 0080FF01
F07F0000 0080FF01 F0FF0000 00C0FF00 F0FF0000 00C0FF00 F0FF0100 00E0FF00
F0FF0300 00E07F00 F0FF0700 00F07F00 F0FF0F00 00F83F00 F0FF1F00 00FC3F00
F0FF3F00 00FF1F00 F0FF7F00 C0FF1F00 F0FFFF03 F8FF0F00 F0FFFF1F FFFF0F00
F0FFFFFF FFFF0700 F0FFFFFF FFFF0300 F07FFFFF FFFF0100 F07FFEFF FFFF0000
F07FF8FF FF7F0000 F07FE0FF FF3F0000 F07F80FF FF070000 F07F00FC FF000000
F07F00F0 00000000 F07F0000 00000000 F07F0000 00000000 F07F0000 00000000
F07F0000 00000000 F07F0000 00000000 E0FF0000 00000000 E0FF0000 00000000
E0FF0000 00000000 E0FF0000 00000000 E0FF0100 0000FC0F C0FF0100 0000FC0F
C0FF0300 0000FE0F 80FF0300 0000FE07 80FF0300 0000FF07 00FF0700 0000FF03
00FF0F00 0080FF03 00FE1F00 00C0FF03 00FE3F00 00E0FF01 00FC7F00 00F0FF01
00FCFF00 00F8FF00 00F8FF03 00FCFF00 00F0FF0F 00FF7F00 00E0FF7F FFFF3F00
00C0FFFF FFFF1F00 0080FFFF FFFF0F00 0000FFFF FFFF0700 0000FEFF FFFF0300
0000FCFF FFFF0100 0000E0FF FFFF0000 000080FF FF1F0000 000000FE FF010000
000000E0 00000000 00000000 00000000 00000000 00000000 00000000 00000000
00000000
End DefineFont